<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.Matrix</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.C.String</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-7"></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span>
</span><span id="line-11"></span><span class="hs-comment">---</span><span>
</span><span id="line-12"></span><span class="hs-comment">-- the good stuff</span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#resetProjection"><span class="hs-identifier hs-type">resetProjection</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190632"><span class="annot"><a href="#local-6989586621679190632"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-16"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190632"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-18"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190632"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-19"></span><span id="resetProjection"><span class="annot"><span class="annottext">resetProjection :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#resetProjection"><span class="hs-identifier hs-var hs-var">resetProjection</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#resetProjection"><span class="hs-identifier hs-var">GPU.resetProjection</span></a></span><span>
</span><span id="line-20"></span><span>
</span><span id="line-21"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#matrixMode"><span class="hs-identifier hs-type">matrixMode</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190623"><span class="annot"><a href="#local-6989586621679190623"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-23"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190623"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#MatrixMode"><span class="hs-identifier hs-type">GPU.MatrixMode</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190623"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-27"></span><span id="matrixMode"><span class="annot"><span class="annottext">matrixMode :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; MatrixMode -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#matrixMode"><span class="hs-identifier hs-var hs-var">matrixMode</span></a></span></span><span> </span><span id="local-6989586621679190592"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190592"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190591"><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679190591"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; MatrixMode -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#matrixMode"><span class="hs-identifier hs-var">GPU.matrixMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190592"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">MatrixMode
</span><a href="#local-6989586621679190591"><span class="hs-identifier hs-var">m</span></a></span><span>
</span><span id="line-28"></span><span>
</span><span id="line-29"></span><span class="hs-comment">-- TODO: setMVP</span><span>
</span><span id="line-30"></span><span class="hs-comment">-- TODO: setMVPFromStack</span><span>
</span><span id="line-31"></span><span>
</span><span id="line-32"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#pushMatrix"><span class="hs-identifier hs-type">pushMatrix</span></a></span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190617"><span class="annot"><a href="#local-6989586621679190617"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-34"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190617"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190617"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span id="pushMatrix"><span class="annot"><span class="annottext">pushMatrix :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#pushMatrix"><span class="hs-identifier hs-var hs-var">pushMatrix</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Matrix.html#pushMatrix"><span class="hs-identifier hs-var">GPU.pushMatrix</span></a></span><span>
</span><span id="line-37"></span><span>
</span><span id="line-38"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#popMatrix"><span class="hs-identifier hs-type">popMatrix</span></a></span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190584"><span class="annot"><a href="#local-6989586621679190584"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-40"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190584"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190584"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-42"></span><span id="popMatrix"><span class="annot"><span class="annottext">popMatrix :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#popMatrix"><span class="hs-identifier hs-var hs-var">popMatrix</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Matrix.html#popMatrix"><span class="hs-identifier hs-var">GPU.popMatrix</span></a></span><span>
</span><span id="line-43"></span><span>
</span><span id="line-44"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#loadIdentity"><span class="hs-identifier hs-type">loadIdentity</span></a></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190579"><span class="annot"><a href="#local-6989586621679190579"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-46"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190579"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190579"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-48"></span><span id="loadIdentity"><span class="annot"><span class="annottext">loadIdentity :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#loadIdentity"><span class="hs-identifier hs-var hs-var">loadIdentity</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Matrix.html#loadIdentity"><span class="hs-identifier hs-var">GPU.loadIdentity</span></a></span><span>
</span><span id="line-49"></span><span class="hs-comment">-- TODO: loadMatrix</span><span>
</span><span id="line-50"></span><span>
</span><span id="line-51"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#ortho"><span class="hs-identifier hs-type">ortho</span></a></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190613"><span class="annot"><a href="#local-6989586621679190613"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-53"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190613"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ left</span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ right</span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ bottom</span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ top</span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ near</span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ far</span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190613"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-61"></span><span id="ortho"><span class="annot"><span class="annottext">ortho :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#ortho"><span class="hs-identifier hs-var hs-var">ortho</span></a></span></span><span> </span><span id="local-6989586621679190572"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190572"><span class="hs-identifier hs-var">n1</span></a></span></span><span> </span><span id="local-6989586621679190571"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190571"><span class="hs-identifier hs-var">n2</span></a></span></span><span> </span><span id="local-6989586621679190570"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190570"><span class="hs-identifier hs-var">n3</span></a></span></span><span> </span><span id="local-6989586621679190569"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190569"><span class="hs-identifier hs-var">n4</span></a></span></span><span> </span><span id="local-6989586621679190568"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190568"><span class="hs-identifier hs-var">n5</span></a></span></span><span> </span><span id="local-6989586621679190567"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190567"><span class="hs-identifier hs-var">n6</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#ortho"><span class="hs-identifier hs-var">GPU.ortho</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190572"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190571"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190570"><span class="hs-identifier hs-var">n3</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190569"><span class="hs-identifier hs-var">n4</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190568"><span class="hs-identifier hs-var">n5</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190567"><span class="hs-identifier hs-var">n6</span></a></span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#frustum"><span class="hs-identifier hs-type">frustum</span></a></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190564"><span class="annot"><a href="#local-6989586621679190564"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-65"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190564"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ left</span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ right</span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ bottom</span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ top</span><span>
</span><span id="line-70"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ near</span><span>
</span><span id="line-71"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ far</span><span>
</span><span id="line-72"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190564"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-73"></span><span id="frustum"><span class="annot"><span class="annottext">frustum :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#frustum"><span class="hs-identifier hs-var hs-var">frustum</span></a></span></span><span> </span><span id="local-6989586621679190561"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190561"><span class="hs-identifier hs-var">n1</span></a></span></span><span> </span><span id="local-6989586621679190560"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190560"><span class="hs-identifier hs-var">n2</span></a></span></span><span> </span><span id="local-6989586621679190559"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190559"><span class="hs-identifier hs-var">n3</span></a></span></span><span> </span><span id="local-6989586621679190558"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190558"><span class="hs-identifier hs-var">n4</span></a></span></span><span> </span><span id="local-6989586621679190557"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190557"><span class="hs-identifier hs-var">n5</span></a></span></span><span> </span><span id="local-6989586621679190556"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190556"><span class="hs-identifier hs-var">n6</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#frustum"><span class="hs-identifier hs-var">GPU.frustum</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190561"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190560"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190559"><span class="hs-identifier hs-var">n3</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190558"><span class="hs-identifier hs-var">n4</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190557"><span class="hs-identifier hs-var">n5</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190556"><span class="hs-identifier hs-var">n6</span></a></span><span>
</span><span id="line-74"></span><span>
</span><span id="line-75"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#perspective"><span class="hs-identifier hs-type">perspective</span></a></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190609"><span class="annot"><a href="#local-6989586621679190609"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-77"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190609"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-78"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ fovy</span><span>
</span><span id="line-79"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ aspect</span><span>
</span><span id="line-80"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ z_near</span><span>
</span><span id="line-81"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ z_far</span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190609"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-83"></span><span id="perspective"><span class="annot"><span class="annottext">perspective :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Float -&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#perspective"><span class="hs-identifier hs-var hs-var">perspective</span></a></span></span><span> </span><span id="local-6989586621679190551"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190551"><span class="hs-identifier hs-var">n1</span></a></span></span><span> </span><span id="local-6989586621679190550"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190550"><span class="hs-identifier hs-var">n2</span></a></span></span><span> </span><span id="local-6989586621679190549"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190549"><span class="hs-identifier hs-var">n3</span></a></span></span><span> </span><span id="local-6989586621679190548"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190548"><span class="hs-identifier hs-var">n4</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#perspective"><span class="hs-identifier hs-var">GPU.perspective</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190551"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190550"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190549"><span class="hs-identifier hs-var">n3</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190548"><span class="hs-identifier hs-var">n4</span></a></span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#lookAt"><span class="hs-identifier hs-type">lookAt</span></a></span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190607"><span class="annot"><a href="#local-6989586621679190607"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-87"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190607"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ eye_x</span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ eye_y</span><span>
</span><span id="line-90"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ eye_z</span><span>
</span><span id="line-91"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ target_x</span><span>
</span><span id="line-92"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ target_y</span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ target_z</span><span>
</span><span id="line-94"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ up_x</span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ up_y</span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ up_z</span><span>
</span><span id="line-97"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190607"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-98"></span><span id="lookAt"><span class="annot"><span class="annottext">lookAt :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#lookAt"><span class="hs-identifier hs-var hs-var">lookAt</span></a></span></span><span> </span><span id="local-6989586621679190543"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190543"><span class="hs-identifier hs-var">n1</span></a></span></span><span> </span><span id="local-6989586621679190542"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190542"><span class="hs-identifier hs-var">n2</span></a></span></span><span> </span><span id="local-6989586621679190541"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190541"><span class="hs-identifier hs-var">n3</span></a></span></span><span> </span><span id="local-6989586621679190540"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190540"><span class="hs-identifier hs-var">n4</span></a></span></span><span> </span><span id="local-6989586621679190539"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190539"><span class="hs-identifier hs-var">n5</span></a></span></span><span> </span><span id="local-6989586621679190538"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190538"><span class="hs-identifier hs-var">n6</span></a></span></span><span> </span><span id="local-6989586621679190537"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190537"><span class="hs-identifier hs-var">n7</span></a></span></span><span> </span><span id="local-6989586621679190536"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190536"><span class="hs-identifier hs-var">n8</span></a></span></span><span> </span><span id="local-6989586621679190535"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190535"><span class="hs-identifier hs-var">n9</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-99"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#lookAt"><span class="hs-identifier hs-var">GPU.lookAt</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190543"><span class="hs-identifier hs-var">n1</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190542"><span class="hs-identifier hs-var">n2</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190541"><span class="hs-identifier hs-var">n3</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190540"><span class="hs-identifier hs-var">n4</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190539"><span class="hs-identifier hs-var">n5</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190538"><span class="hs-identifier hs-var">n6</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190537"><span class="hs-identifier hs-var">n7</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190536"><span class="hs-identifier hs-var">n8</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190535"><span class="hs-identifier hs-var">n9</span></a></span><span>
</span><span id="line-100"></span><span>
</span><span id="line-101"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#translate"><span class="hs-identifier hs-type">translate</span></a></span><span>
</span><span id="line-102"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190605"><span class="annot"><a href="#local-6989586621679190605"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-103"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190605"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-105"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-106"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ z</span><span>
</span><span id="line-107"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190605"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-108"></span><span id="translate"><span class="annot"><span class="annottext">translate :: forall (m :: * -&gt; *). MonadIO m =&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#translate"><span class="hs-identifier hs-var hs-var">translate</span></a></span></span><span> </span><span id="local-6989586621679190530"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190530"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190529"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190529"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190528"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190528"><span class="hs-identifier hs-var">z</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#translate"><span class="hs-identifier hs-var">GPU.translate</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190530"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190529"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190528"><span class="hs-identifier hs-var">z</span></a></span><span>
</span><span id="line-109"></span><span>
</span><span id="line-110"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#scale"><span class="hs-identifier hs-type">scale</span></a></span><span>
</span><span id="line-111"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190525"><span class="annot"><a href="#local-6989586621679190525"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-112"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190525"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-113"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ sx</span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ sy</span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ sz</span><span>
</span><span id="line-116"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190525"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-117"></span><span id="scale"><span class="annot"><span class="annottext">scale :: forall (m :: * -&gt; *). MonadIO m =&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#scale"><span class="hs-identifier hs-var hs-var">scale</span></a></span></span><span> </span><span id="local-6989586621679190522"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190522"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190521"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190521"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190520"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190520"><span class="hs-identifier hs-var">z</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#scale"><span class="hs-identifier hs-var">GPU.scale</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190522"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190521"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190520"><span class="hs-identifier hs-var">z</span></a></span><span>
</span><span id="line-118"></span><span>
</span><span id="line-119"></span><span class="annot"><a href="SDL.GPU.Simple.Matrix.html#rotate"><span class="hs-identifier hs-type">rotate</span></a></span><span>
</span><span id="line-120"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190517"><span class="annot"><a href="#local-6989586621679190517"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-121"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190517"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ degrees</span><span>
</span><span id="line-123"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-124"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-125"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ z</span><span>
</span><span id="line-126"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190517"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-127"></span><span id="rotate"><span class="annot"><span class="annottext">rotate :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Float -&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Matrix.html#rotate"><span class="hs-identifier hs-var hs-var">rotate</span></a></span></span><span> </span><span id="local-6989586621679190514"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190514"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679190513"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190513"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190512"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190512"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190511"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190511"><span class="hs-identifier hs-var">z</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Matrix.html#rotate"><span class="hs-identifier hs-var">GPU.rotate</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190514"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190513"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190512"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190511"><span class="hs-identifier hs-var">z</span></a></span><span>
</span><span id="line-128"></span><span>
</span><span id="line-129"></span><span class="hs-comment">-- TODO: multMatrix</span><span>
</span><span id="line-130"></span></pre></body></html>